<?php 
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class DescontosTipoConsumidorReportHandler extends AReportHandler {
    const ANALITICO = 'vnd55017_relDecontosTipoConsumidorExportAnalitico';
    const SINTETICO = 'vnd55017_relDecontosTipoConsumidorExportSintetico';
    
    public function buildNewRequest($request, Response $response) {
        $conditions = $this->relService->getParamsAsArray($request);
        $this->conditionsMake($conditions);    
        unset($conditions['NRORG']);
        unset($conditions['DTENTRVENDA']);
        if($conditions['TIPORELATORIO'] == 'A'){
            $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::ANALITICO, $conditions);
        }
        else{
            $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::SINTETICO, $conditions);
        }
        
        return [$newRequest, $response];
    }
    
    public function conditionsMake(&$conditions){
        if (isset($conditions['CDFILIAL'])){
            if(is_array($conditions['CDFILIAL'])){
                $conditions['TCDFILIAL'] = 'F';
                $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            }
            else{
                $conditions['CDFILIAL'] = null;
                $conditions['TCDFILIAL'] = 'T';
            }
        }else{
            $conditions['CDFILIAL'] = null;
            $conditions['TCDFILIAL'] = 'T';
        }
        
        if (isset($conditions['CDLOJA'])){
            if(is_array($conditions['CDLOJA'])){
                $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            }
        }
        
        if (isset($conditions['CDCLIENTE'])){
            if(is_array($conditions['CDCLIENTE'])){
                $conditions['TCDCLIENTE'] = 'F';
                $conditions['CDCLIENTE'] = implode('_', $conditions['CDCLIENTE']);
            }
            else{
                $conditions['CDCLIENTE'] = NULL;
                $conditions['TCDCLIENTE'] = 'T';
            }
        }else{
            $conditions['CDCLIENTE'] = NULL;
            $conditions['TCDCLIENTE'] = 'T';
        }
        if (isset($conditions['CDCONSUMIDOR'])){
            if(is_array($conditions['CDCONSUMIDOR'])){
                $conditions['TCDCONSUMIDOR'] = 'F';
                $conditions['CDCONSUMIDOR'] = implode('_', $conditions['CDCONSUMIDOR']);
            }
            else{
                $conditions['CDCONSUMIDOR'] = NULL;
                $conditions['TCDCONSUMIDOR'] = 'T';
            }
        }else{
            $conditions['CDCONSUMIDOR'] = NULL;
            $conditions['TCDCONSUMIDOR'] = 'T';
        }
        if (isset($conditions['CDTIPOCONS'])){
            if(is_array($conditions['CDTIPOCONS'])){
                $conditions['TCDTIPOCONS'] = 'F';
                $conditions['CDTIPOCONS'] = implode('_', $conditions['CDTIPOCONS']);
            }
            else{
                $conditions['CDTIPOCONS'] = NULL;
                $conditions['TCDTIPOCONS'] = 'T';
            }
        }else{
            $conditions['CDTIPOCONS'] = NULL;
            $conditions['TCDTIPOCONS'] = 'T';
        }
        $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
        $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
    }
   
}