<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services;

class SelectProdutoRelVenProdCons extends CrudWithParameterBag{
    
    protected $dataSourceName = 'vnd03700_selectProduto';
    const adqProdutoSegFam = 'adqProdutoSegFam';
    const adqProdutoFamilia = 'adqProdutoFamilia';
    const adqProdutoSegmento = 'adqProdutoSegmento';
    
    protected $parameterBagColumns = array('NRORG','CDFILIAL','CDNVPRODUTO');
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $util, 
    Services\SelectProdutoRelVenProdCons $service) {
        $this->util = $util;
        $this->service = $service;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $conditions = $this->util->getParamsAsArray($request);
        $adqParametros = $this->service->adqParametros($conditions);
        if(!empty($adqParametros['CDGRPRODPDV'])){
            if(!empty($adqParametros['CDSEGMER'])){
                $this->dataSourceName = self::adqProdutoSegFam;
            }else{
                $this->dataSourceName = self::adqProdutoFamilia;
            }
        }else{
            if(!empty($adqParametros['CDSEGMER'])){
                $this->dataSourceName = self::adqProdutoSegmento;
            }
        }
        parent::find($request,$response);
    }
}